<?php
/**
 * @subpackage	mod_lotto
 * @copyright	Copyright (C) 2012 Ben Tasker . All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */


// no direct access
defined('_JEXEC') or die;

class modLivingStreetsHelper
{
	
function setparams($params){
$this->params = $params;
}

    

      function WorkplaceResults(){

      $shortcache = $this->params->get('shortcache') * 60;
      $workplace = $this->params->get('workplace');

//$uri = "http://www.livingstreets.org.uk/workplace/$workplace";
//return json_decode($this->place_request($uri));


       // Get the config object from factory
        $conf =& JFactory::getConfig();
        // Get the current cachetime value
        $cachetime = $conf->getValue('config.cachetime');
        
	
        $conf->setValue('config.cachetime', $shortcache);
	



        // Get the Cache object
        $cache =& JFactory::getCache('mod_livingstreets_workplace_position'.$workplace, 'output');
        // Enable caching (if disabled in global configuration)
        $cache->setCaching( 1 );
        // Try to get the results from cache


    if (!($json = $cache->get('mod_livingstreets_workplace_position'.$workplace))) {
            $uri = "http://www.livingstreets.org.uk/workplace/$workplace";
            
           
            if ($json = $this->place_request($uri)) {
                // Store the data in cache
                if (!$cache->store($json, 'mod_livingstreets_workplace_position'.$workplace)) {
                    // If storing in cache failed then we will return the error
                    $error = 'cache';
                }
            } else {
                $error = 'Could not retrieve';
            }
        }

return json_decode($json);

      }






function place_request($uri){

unset($this->result);
// Check whether we can use File or if we need to resort to Curl
if (ini_get('allow_url_fopen')){
$results = $this->placefilerequest($uri);
}else{
$results = $this->placecurlrequest($uri);

}


$X = 0;
foreach ($results as $line){




if ((strpos($line,"class=\"shout\"") === false) && (strpos($line,"Total:") === false)){ continue; }

//echo $line;

$divider = explode(">",$line);
$X++;
// Tidy the output
$stats["stat$X"] = str_replace("</p","",str_replace("Total: ","", str_replace("<p","",str_replace(" Calories","",str_replace(" miles","",str_replace("<sub","",$divider[1]))))));

}


// See if the workplace is in the top 20


unset($results);

if (ini_get('allow_url_fopen')){
$results = $this->placefilerequest("http://www.livingstreets.org.uk/workplace/top-workplaces");
}else{
$results = $this->placecurlrequest("http://www.livingstreets.org.uk/workplace/top-workplaces");
}


$rank = false;

if ($this->params->get('getRanking')){

foreach ($results as $ranking){

if (strpos($ranking,$this->params->get('WorkplaceLSDisplay')) === false){ continue; }

$contenders = explode("<tr>",$ranking);
foreach ($contenders as $co){
if (strpos($co,$this->params->get('WorkplaceLSDisplay')) === false) { continue; }

$copos = explode("<td>",$co);
$rank = str_replace("</td>","",$copos[1]);
break;

}
break;

}

}

$result->Muffins = $stats['stat1'];
$result->Calories = $stats['stat2'];
$result->LandsEnd = $stats['stat3']; 
$result->Miles = $stats['stat4'];
$result->CO2 = $stats['stat5'];
$result->rank = $rank;

return json_encode($result);

}








function placefilerequest($uri){

$results = file($uri);

return $results;
}



function placecurlrequest($uri){
 $ch = curl_init("$uri");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
 
    $data = curl_exec($ch);
 
    curl_close($ch);
$data = explode("\n",$data);

return $data;
}


}
